//     

//   ,       
//               
//    !!
//           ( )
//        
// (..     ,     ,      )
//
// -   ,     
//     -   
//       , 
//        ,        
//
// (c) Proteus

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>

#define DONE	(node_st*)-1	//!<    (-       )

#define SIZE 5000	//!<  

struct node_st{node_st *p1;node_st *p2; int value; bool pass;}; // pass    
node_st array[SIZE];


//!<  
void Install()
{
	int n,m;
	for(n=0; n<SIZE; n++) {
		array[n].p1=array[n].p2=0; array[n].value=1+rand()%100; array[n].pass=true;
		if(n)for(;;) {
			m=rand()%n;
			if(!array[m].p1) array[m].p1=&array[n]; else
			if(!array[m].p2) array[m].p2=&array[n]; else
			continue;
			break;
		}
	}
}


//!  
//! \param node     
//! \param vector     
//! \param index      (    )
void TestWalk(node_st *node,int vector[SIZE],int &index)
{
	if(!node) return;
	if(index>SIZE) return; // 
	vector[index++]=node->value;
	TestWalk(node->p1,vector,index);
	TestWalk(node->p2,vector,index);
}

//!  
//!   
void Walk(node_st *node,int vector[SIZE])
{
	int index=0;
	node_st *p1,*parent=DONE; //   
	while(node!=DONE){
		if(index>SIZE) return; // 
		if(node->pass) vector[index++]=node->value,node->pass=false;
		p1=node->p1;
		node->p1=node->p2;
		if(node==parent) node->p2=0; else node->p2=parent;
		parent=node;
		if(p1) node=p1; 
	}
}


int vector1[SIZE+1],vector2[SIZE+1]; //  


void main()
{
	int index=0; 
	memset(vector1,0,sizeof(vector1)); memset(vector2,0,sizeof(vector2));
	Install();
	Walk(&array[0],vector2);			//   
	TestWalk(&array[0],vector1,index);	//   ( )
	if(memcmp(vector1,vector2,sizeof(vector1))) printf("Internal error\n\a");
	else printf("Ok. (count=%d)\n",index);
	getchar();
}
